using System;
using System.Collections.Generic;
using MarketplaceWebServiceProducts;
using MarketplaceWebServiceProducts.Model;

public class MwsTest {
        private static string accessKeyId     = "";		// ݒ肵ĂII
        private static string secretAccessKey = "";		// ݒ肵ĂII
        private static string merchantId      = "";		// ݒ肵ĂII
        private static string marketplaceId   = "";		// ݒ肵ĂII
   
    //****************************************************************************
    // Function     : Main
    // Description  : C
    //****************************************************************************
    public static void Main(string [] args) {

        MarketplaceWebServiceProductsConfig config = new MarketplaceWebServiceProductsConfig();
        config.ServiceURL = "https://mws.amazonservices.jp/Products/2011-10-01";

        //-------------------------------------
        // WebServiceIuWFNg擾
        //-------------------------------------
        MarketplaceWebServiceProductsClient service = new MarketplaceWebServiceProductsClient(
                         "nanoappli.com_sample", "1.0.0.0", accessKeyId, secretAccessKey, config);
    
 
        //-------------------------------
        // NGXgp[^̃Zbg
        //-------------------------------
        GetLowestOfferListingsForASINRequest request = new GetLowestOfferListingsForASINRequest();

        ASINListType asinList = new ASINListType();
        asinList.ASIN = new List<string>();
        asinList.ASIN.Add( "4478312141" );
        asinList.ASIN.Add( "4797330058" );

        request.ASINList      = asinList;
        request.SellerId      = merchantId;
        request.MarketplaceId = marketplaceId;

        //-------------------------------
        // MWSNGXgAPI̎s
        //-------------------------------
        GetLowestOfferListingsForASINResponse response = null;
        try {
            response = service.GetLowestOfferListingsForASIN(request);
        } 
        catch (MarketplaceWebServiceProductsException ex) 
        {
            Console.WriteLine("Caught Exception: " + ex.Message);
            Console.WriteLine("Response Status Code: " + ex.StatusCode);
            Console.WriteLine("Error Code: " + ex.ErrorCode);
            Console.WriteLine("Error Type: " + ex.ErrorType);
            Console.WriteLine("Request ID: " + ex.RequestId);
            Console.WriteLine("XML: " + ex.XML);
            Console.WriteLine("ResponseHeaderMetadata: " + ex.ResponseHeaderMetadata);
        }

        showResponse( response );

        Console.WriteLine("hit any key");
        Console.ReadKey();
    }


    //****************************************************************************
    // Function     : showResponse
    // Description  : WebT[rXsʂ̕\
    // Params       : response WebAPIs
    //****************************************************************************
    public static void showResponse( GetLowestOfferListingsForASINResponse response ) {         
                
        List<GetLowestOfferListingsForASINResult> resultList = response.GetLowestOfferListingsForASINResult;
        foreach (GetLowestOfferListingsForASINResult getLowestOfferListingsForASINResult in resultList) {
            Console.WriteLine ("=============================================================================");
            if (getLowestOfferListingsForASINResult.IsSetstatus()) {
                Console.WriteLine("Status : {0}",  getLowestOfferListingsForASINResult.status);
            } 

            //----------------
            // ȉ
            //----------------
            if (getLowestOfferListingsForASINResult.IsSetASIN()) {
                Console.WriteLine("ASIN  : {0}",  getLowestOfferListingsForASINResult.ASIN);
            } 

            if (getLowestOfferListingsForASINResult.IsSetProduct()) {
                Product  product = getLowestOfferListingsForASINResult.Product;

                if (product.IsSetSalesRankings()){
                    SalesRankList  salesRankings = product.SalesRankings;
                    List<SalesRankType> salesRankList = salesRankings.SalesRank;
                    foreach (SalesRankType salesRank in salesRankList) {
                        Console.WriteLine("                        SalesRank");
                        if (salesRank.IsSetProductCategoryId())
                        {
                            Console.WriteLine("JeSID :{0}", salesRank.ProductCategoryId);
                        }
                        if (salesRank.IsSetRank())
                        {
                            Console.WriteLine("N :{0}", salesRank.Rank);
                        }
                    }
                }


                if (product.IsSetLowestOfferListings()) {
                    LowestOfferListingList  lowestOfferListings = product.LowestOfferListings;
                    List<LowestOfferListingType> lowestOfferListingList = lowestOfferListings.LowestOfferListing;

                    //-----------------------------------------
                    // 擾Soi\܂ŌJԂ
                    //-----------------------------------------
                    foreach (LowestOfferListingType lowestOfferListing in lowestOfferListingList) {
                        Console.WriteLine("------------------------------------------------");

                        if (lowestOfferListing.IsSetQualifiers()) {
                            QualifiersType  qualifiers = lowestOfferListing.Qualifiers;
                            if (qualifiers.IsSetItemCondition()) {
                                String condName    = getConditionName( qualifiers.ItemCondition );
                                String subCondName = "";
                                if (qualifiers.IsSetItemSubcondition()) {
                                    subCondName = getItemSubconditionName( qualifiers.ItemSubcondition );
                                }
                                Console.WriteLine("RfBV   :{0} {1}", condName, subCondName );

                            }

                            if (qualifiers.IsSetFulfillmentChannel()) {
                                string name = getFulfillmentChannelName( qualifiers.FulfillmentChannel );
                                Console.WriteLine("o׌           :{0}", name );
                            }
                            if (qualifiers.IsSetShipsDomestically()) {
                                Console.WriteLine("蔭     :{0}", qualifiers.ShipsDomestically);
                            }
                            if (qualifiers.IsSetShippingTime() && qualifiers.ShippingTime.IsSetMax()) {
                                Console.WriteLine("(ő)   :{0}", qualifiers.ShippingTime.Max);
                            }
                            if (lowestOfferListing.IsSetSellerFeedbackCount()) {
                                Console.Write("tB[hobN :{0}", lowestOfferListing.SellerFeedbackCount);
                                if (qualifiers.IsSetSellerPositiveFeedbackRating()) {
                                    Console.Write(" (]:{0})", qualifiers.SellerPositiveFeedbackRating);
                                }
                                Console.WriteLine("");
                            }


                        }
                        if (lowestOfferListing.IsSetNumberOfOfferListingsConsidered()) {
                            Console.WriteLine( "oi           :{0}", lowestOfferListing.NumberOfOfferListingsConsidered);
                        }

                        //------------------
                        // i
                        //------------------
                        if (lowestOfferListing.IsSetPrice()) {
                            PriceType  price1 = lowestOfferListing.Price;
                            if (price1.IsSetLandedPrice()) {
                                Console.Write( "z             :" + getPriceName( price1.LandedPrice ) );
                            }

                            if (price1.IsSetShipping()) {
                                Console.WriteLine( "(:" + getPriceName( price1.Shipping ) + ")" );
                            }
                        }
                    }
                }


            }

            if (getLowestOfferListingsForASINResult.IsSetError()) {
                Console.WriteLine( "G[܂" );
                Error  error = getLowestOfferListingsForASINResult.Error;
                if (error.IsSetType()) {
                    Console.WriteLine("Type: {0}", error.Type);
                }
                if (error.IsSetCode()) {
                    Console.WriteLine("Code: {0}", error.Code);
                }
                if (error.IsSetMessage()) {
                    Console.WriteLine("Message: {0}", error.Message);
                }
            }
        }

    }


    //****************************************************************************
    // Function     : getConditionName
    // Description  : RfBV({)擾
    //****************************************************************************
    private static string getConditionName( string inStr ) {
        switch( inStr ) {
            case "New":
                return "Vi";
            case "Used":
                return "Õi";
            case "Collectible":
                return "RN^[i";
            case "Refurbished":
                return "Đi";
            default:
                return inStr;
        }
    }

    //****************************************************************************
    // Function     : getItemSubconditionName
    // Description  : TuRfBV({)擾
    //****************************************************************************
    private static string getItemSubconditionName( string inStr ) {
        switch( inStr ) {
            case "New":
                return "Vi";
            case "Mint":
                return "قڐVi";
            case "Very Good":
            case "VeryGood":
                return "ɗǂ";
            case "Good":
                return "ǂ";
            default:
                return inStr;
        }
    }

    //****************************************************************************
    // Function     : getFulfillmentChannelName
    // Description  : o׌({)擾
    //****************************************************************************
    private static string getFulfillmentChannelName( string inStr ) {
        switch( inStr ) {
            case "Amazon":
                return "FBA";
            case "Merchant":
                return "oi";
            default:
                return inStr;
        }
    }
 
 
    //****************************************************************************
    // Function     : getPriceName
    // Description  : i(ʉݒPʕt)擾
    //****************************************************************************
    private static string getPriceName( MoneyType inData ) {
        string outStr = "";
 
        // ʉݒPʂ̃Zbg
        if ( inData.IsSetCurrencyCode() ) {
            switch ( inData.CurrencyCode ) {
                case "JPY":
                    outStr += "\\";
                    break;
                case "USD":
                    outStr += "$";
                    break;
                default:
                    outStr += "(" + inData.CurrencyCode + ")";
                    break;
            }
        }
 
        // z̃Zbg
        if ( inData.IsSetAmount()) {
            outStr += String.Format( "{0:0}", inData.Amount );
        }
 
        return outStr;
    }
}

